; *** INTEQUATES.ASM

; *** INTUITION CONSTANTS, ROUTINE OFFSETS, AND STRUCTURAL OFFSETS

ACTIVATE		EQU $1000
ACTIVEWINDOW		EQU $40000
ALTKEYMAP		EQU $1000
AUTOKNOB		EQU $1

BACKDROP		EQU $100
BEEPING		EQU $20
BOOLGADGET		EQU $1

; *** BORDER STRUCTURE OFFSETS

BORD.BACKPEN		EQU $5
BORD.COUNT		EQU $7
BORD.DRAWMODE		EQU $6
BORD.FRONTPEN		EQU $4
BORD.LEFTEDGE		EQU $0
BORD.NEXT		EQU $C
BORD.TOPEDGE		EQU $2
BORD.XY		EQU $8
BORDERLESS		EQU $800
BOTTOMBORDER		EQU $80

CHECKED		EQU $100
CHECKIT		EQU $1
CLOSE		EQU $80
CLOSEWINDOW		EQU $200
COMMSEQ		EQU $4
CUSTOM		EQU $40
CUSTOMBITMAP		EQU $40
CUSTOMSCREEN		EQU $F

DELTAMOVE		EQU $100000
DISKINSERTED		EQU $8000
DISKREMOVED		EQU $10000

ENDGADGET		EQU $4

FOLLOWMOUSE		EQU $8
FREEHORIZ		EQU $2
FREEVERT		EQU $4

; *** GADGET STRUCTURE OFFSETS

GADG.ACTIVATION	EQU $E
GADG.FLAGS		EQU $C
GADG.HEIGHT		EQU $A
GADG.ID		EQU $26
GADG.LEFTEDGE		EQU $4
GADG.MUTUALEXCLUDE	EQU $1E
GADG.NEXT		EQU $0
GADG.RENDER		EQU $12
GADG.SELECTRENDER	EQU $16
GADG.SPECIALINFO	EQU $22
GADG.TEXT		EQU $1A
GADG.TOPEDGE		EQU $6
GADG.TYPE		EQU $10
GADG.USERDATA		EQU $28
GADG.WIDTH		EQU $8

GADGBACKFILL		EQU $1
GADGDISABLED		EQU $100
GADGET0002		EQU $2
GADGETDOWN		EQU $20
GADGETTYPE		EQU $FC00
GADGETUP		EQU $40
GADGHBOX		EQU $1
GADGHCOMP		EQU $0
GADGHIGHBITS		EQU $3
GADGHIMAGE		EQU $2
GADGHNONE		EQU $3
GADGIMAGE		EQU $4
GADGIMMEDIATE		EQU $2
GIMMEZEROZERO		EQU $400
GRELBOTTOM		EQU $8
GRELHEIGHT		EQU $40
GRELRIGHT		EQU $10
GRELWIDTH		EQU $20
GZZGADGET		EQU $2000

HIGHBOX		EQU $80
HIGHCOMP		EQU $40
HIGHFLAGS		EQU $C0
HIGHIMAGE		EQU $0
HIGHITEM		EQU $2000
HIGHNONE		EQU $C0

; *** INTUITION BASE OFFSETS

IB.ACTIVEWINDOW		EQU $34
IB.ACTIVESCREEN		EQU $38
IB.FIRSTSCREEN		EQU $3C

; *** INTUITION STRUCTURE OFFSETS

IM.CLASS		EQU $14
IM.CODE		EQU $18
IM.IADDRESS		EQU $1C
IM.IDCMPWINDOW		EQU $2C
IM.MESSAGE		EQU $0
IM.MICROS		EQU $28
IM.MOUSEX		EQU $20
IM.MOUSEY		EQU $22
IM.QUALIFIER		EQU $1A
IM.SECONDS		EQU $24
IM.SPECIALLINK		EQU $30

IMAG.LEFTEDGE		EQU 0
IMAG.TOPEDGE		EQU 2
IMAG.WIDTH		EQU 4
IMAG.HEIGHT		EQU 6
IMAG.DEPTH		EQU 8
IMAG.IMAGEDATA		EQU 10
IMAG.PLANEPICK		EQU 14
IMAG.PLANEONOFF		EQU 15
IMAG.NEXTIMAGE		EQU 16

INACTIVEWINDOW		EQU $80000
INREQUEST		EQU $4000
INTUITICKS		EQU $400000
ISDRAW		EQU $1000

; *** INTUITEXT STRUCTURE OFFSETS

IT.BACKPEN		EQU $1
IT.DRAWMODE		EQU $2
IT.FONT		EQU $8
IT.FRONTPEN		EQU $0
IT.LEFTEDGE		EQU $4
IT.NEXT		EQU $10
IT.PAD		EQU $3
IT.TEXT		EQU $C
IT.TOPEDGE		EQU $6

ITEMENABLED		EQU $10
ITEMTEXT		EQU $2

KNOBHIT		EQU $100
KNOBHMIN		EQU $6
KNOBVMIN		EQU $4

LEFTBORDER		EQU $20

; *** INTUITION LIBRARY OFFSETS

LVO.ADDGADGET		EQU $FFFFFFD6
LVO.ALLOCREMEMBER	EQU $FFFFFE74
LVO.AUTOREQUEST	EQU $FFFFFEA4
LVO.CLEARDMREQUEST	EQU $FFFFFFD0
LVO.CLEARMENUSTRIP	EQU $FFFFFFCA
LVO.CLOSESCREEN	EQU $FFFFFFBE
LVO.CLOSEWINDOW	EQU $FFFFFFB8
LVO.CLOSEWORKBENCH	EQU $FFFFFFB2
LVO.DISPLAYBEEP	EQU $FFFFFFA0
LVO.DRAWBORDER		EQU $FFFFFF94
LVO.DRAWIMAGE		EQU $FFFFFF8E
LVO.ENDREQUEST		EQU $FFFFFF88
LVO.FREEREMEMBER	EQU $FFFFFE68
LVO.INTUITEXTLENGTH	EQU $FFFFFEB6
LVO.MODIFYIDCMP	EQU $FFFFFF6A
LVO.MODIFYPROP		EQU $FFFFFF64
LVO.MOVESCREEN		EQU $FFFFFF5E
LVO.MOVEWINDOW		EQU $FFFFFF58
LVO.OFFGADGET		EQU $FFFFFF52
LVO.OFFMENU		EQU $FFFFFF4C
LVO.ONGADGET		EQU $FFFFFF46
LVO.ONMENU		EQU $FFFFFF40
LVO.OPENSCREEN		EQU $FFFFFF3A
LVO.OPENWINDOW		EQU $FFFFFF34
LVO.OPENWORKBENCH	EQU $FFFFFF2E
LVO.PRINTITEXT		EQU $FFFFFF28
LVO.REFRESHGADGETS	EQU $FFFFFF22
LVO.REMOVEGADGET	EQU $FFFFFF1C
LVO.REPORTMOUSE	EQU $FFFFFF16
LVO.REQUEST		EQU $FFFFFF10
LVO.SCREENTOBACK	EQU $FFFFFF0A
LVO.SCREENTOFRONT	EQU $FFFFFF04
LVO.SETDMREQUEST	EQU $FFFFFEFE
LVO.SETMENUSTRIP	EQU $FFFFFEF8
LVO.SETWINDOWTITLES	EQU $FFFFFEEC
LVO.SETWTITLE		EQU $FFFFFEE6
LVO.SHOWWINDOW		EQU $FFFFFEE0
LVO.VIEWPORTADDRESS	EQU $FFFFFED4
LVO.WINDOWTOBACK	EQU $FFFFFECE
LVO.WINDOWTOFRONT	EQU $FFFFFEC8

MAXBODY		EQU $FFFF
MAXPOT		EQU $FFFF

; *** MENU STRUCTURE OFFSETS

MENU.BEATX		EQU $1A
MENU.BEATY		EQU $1C
MENU.FIRSTITEM		EQU $12
MENU.FLAGS		EQU $C
MENU.HEIGHT		EQU $A
MENU.JAZZX		EQU $16
MENU.JAZZY		EQU $18
MENU.LEFTEDGE		EQU $4
MENU.NAME		EQU $E
MENU.NEXT		EQU $0
MENU.TOPEDGE		EQU $6
MENU.WIDTH		EQU $8

MENUCANCEL		EQU $2
MENUDOWN		EQU $69
MENUENABLED		EQU $1
MENUHOT		EQU $1
MENUNULL		EQU $FFFF
MENUPICK		EQU $100
MENUSTATE		EQU $8000
MENUTOGGLE		EQU $8
MENUTOGGLED		EQU $4000
MENUUP		EQU $E9
MENUVERIFY		EQU $2000
MENUWAITING		EQU $3

; *** MENUITEM STRUCTURE OFFSETS

MI.COMMAND		EQU $1A
MI.FLAGS		EQU $C	
MI.HEIGHT		EQU $A
MI.ITEMFILL		EQU $12
MI.LEFTEDGE		EQU $4
MI.MUTUALEXCLUDE	EQU $E
MI.NEXT		EQU $0
MI.NEXTSELECT		EQU $20
MI.PAD		EQU $18
MI.SELECTFILL		EQU $16
MI.SUBITEM		EQU $1C
MI.TOPEDGE		EQU $6
MI.WIDTH		EQU $8

MIDRAW		EQU $100
MOUSEBUTTONS		EQU $8
MOUSEMOVE		EQU $10

NEWPREFS		EQU $4000
NEWSIZE		EQU $2
NOCAREREFRESH		EQU $20000

; *** NEWWINDOW STRUCTURE OFFSETS

NW.BITMAP		EQU $22
NW.BLOCKPEN		EQU $9
NW.CHECKMARK		EQU $16
NW.DETAILPEN		EQU $8
NW.FIRSTGADGET		EQU $12
NW.FLAGS		EQU $E
NW.HEIGHT 		EQU $6
NW.IDCMPFLAGS		EQU $A
NW.LEFTEDGE		EQU $0
NW.MAXHEIGHT		EQU $2C
NW.MAXWIDTH		EQU $2A
NW.MINHEIGHT		EQU $28
NW.MINWIDTH		EQU $26
NW.SCREEN		EQU $1E
NW.TITLE		EQU $1A
NW.TOPEDGE		EQU $2
NW.TYPE		EQU $2E
NW.WIDTH		EQU $4

OTHER_REFRESH		EQU $C0

; *** PROPINFO STRUCTURE OFFSETS

PI.CHEIGHT		EQU $C
PI.CWIDTH		EQU $A
PI.FLAGS		EQU $0
PI.HORIZBODY		EQU $6
PI.HORIZPOT		EQU $2
PI.HPOTRES		EQU $E
PI.LEFTBORDER		EQU $12
PI.TOPBORDER		EQU $14
PI.VERTBODY		EQU $8
PI.VERTPOT		EQU $4
PI.VPOTRES		EQU $10

POINTREL		EQU $1
PREDRAW		EQU $2
PROPBORDERLESS		EQU $8
PROPGADGET		EQU $3

RAWKEY		EQU $400
REFRESHBITS		EQU $C0
REFRESHWINDOW		EQU $4
RELVERIFY		EQU $1
REQACTIVE		EQU $2000
REQCLEAR		EQU $1000
REQGADGET		EQU $1000
REQOFFWINDOW		EQU $1000
REQSET		EQU $80
REQVERIFY		EQU $800
RIGHTBORDER		EQU $10
RMBTRAP		EQU $10000

SCREENTYPE 		EQU $F
SCRGADGET		EQU $4000

; *** SCREEN STRUCTURE OFFSETS

SCRN.MOUSEX		EQU $12
SCRN.MOUSEY		EQU $10
SCRN.RASTPORT		EQU $54
SCRN.VIEWPORT		EQU $2C
SCRN.TITLE		EQU $16
SCRN.WIDTH		EQU $C
SCRN.HEIGHT		EQU $E
SCRN.BITMAP		EQU 184
SCRN.FLAGS		EQU 20

SELECTDOWN		EQU $68
SELECTED		EQU $80
SELECTUP		EQU $E8
SHOWTITLE		EQU $10

; *** STRINGINFO STRUCTURE OFFSETS

SI.ALTKEYMAP		EQU $20
SI.BUFFER		EQU $0
SI.BUFFERPOS		EQU $8
SI.CLEFT		EQU $14
SI.CTOP		EQU $16
SI.DISPCOUNT		EQU $12
SI.DISPPOS		EQU $C
SI.LAYERPTR		EQU $18
SI.LONGINT		EQU $1C
SI.MAXCHARS		EQU $A
SI.NUMCHARS		EQU $10
SI.UNDOBUFFER		EQU $4
SI.UNDOPOS		EQU $E

SIMPLE_REFRESH		EQU $40

; *** VARIOUS STRUCTURE SIZES

SIZE.BORD		EQU $10
SIZE.GADG		EQU $2C
SIZE.IM		EQU $34
SIZE.IMAG		EQU $14
SIZE.IT		EQU $14
SIZE.MENU		EQU $1E
SIZE.MI		EQU $22
SIZE.NS		EQU $20
SIZE.NW		EQU $30
SIZE.PI		EQU $16
SIZE.REQ		EQU $70
SIZE.SCRN		EQU $15C
SIZE.SI		EQU $24

SIZEBOTTOM		EQU $20
SIZEBRIGHT		EQU $10
SIZEVERIFY		EQU $1
SIZING		EQU $10

; *** STARTUP MESSAGE OFFSETS

SM.ARGLIST		EQU $24
SM.MESSAGE		EQU $0
SM.NUMARGS		EQU $1C
SM.PROCESS		EQU $14
SM.SEGMENT		EQU $18
SM.TOOLWINDOW		EQU $20

SMART_REFRESH		EQU $0
STRGADGET		EQU $4
STRINGCENTER		EQU $200
STRINGRIGHT		EQU $400
SUPER_BITMAP		EQU $80
SYSGADGET		EQU $8000
SYSREQUEST		EQU $4000

TOGGLESELECT		EQU $100
TOPBORDER		EQU $40

VANILLAKEY		EQU $200000

WA.LOCK		EQU $0
WA.NAME		EQU $4
WBENCHMESSAGE		EQU $20000
WBENCHSCREEN		EQU $1
WBENCHWINDOW		EQU $2000000

; *** WINDOW & IDCMP FLAGS DEFINITIONS

WINDOWACTIVE		EQU $2000
WINDOWCLOSE		EQU $8
WINDOWDEPTH		EQU $4
WINDOWDRAG		EQU $2
WINDOWREFRESH		EQU $1000000
WINDOWSIZING		EQU $1
WINDOWTICKED		EQU $4000000

; *** WINDOW STRUCTURE OFFSETS

WW.FLAGS		EQU $18
WW.HEIGHT		EQU $A
WW.IDCMPFLAGS		EQU $52
WW.MOUSEX		EQU $E
WW.MOUSEY		EQU $C
WW.RPORT		EQU $32
WW.SCREENTITLE		EQU $68
WW.TITLE		EQU $20
WW.USERPORT		EQU $56
WW.WINDOWPORT		EQU $5A
WW.WSCREEN		EQU $2E
WW.WIDTH		EQU $8
WW.TOPEDGE		EQU $6
WW.LEFTEDGE		EQU $4
