/*********************************************/
/**************   commodore.c   **************/
/*********************************************/

#include <clib/intuition_protos.h>
#include <clib/exec_protos.h>
#include <clib/dos_protos.h>
#include <clib/graphics_protos.h>
#include <clib/layers_protos.h>

#include <exec/types.h>
#include <exec/nodes.h>
#include <exec/lists.h>
#include <exec/ports.h>

#include <intuition/intuition.h>
#include <intuition/intuitionbase.h>
#include <graphics/displayinfo.h>
#include <graphics/gfxbase.h>

#include "consts.h"
#include "structs.h"
#include "proto.h"

void andysCloseWindowSafely(struct Window *win)
   {
   Forbid();

   if (win->UserPort)				/* <- Andy's bit */
      StripIntuiMessages(win->UserPort,win);

   win->UserPort = NULL;

   ModifyIDCMP(win,0L);

   Permit();

   CloseWindow(win);
   }

