;**************************************************************
;
; $VER: SwazInfo Include 1.0 Copyright 1994 David Swasbrook
; $TIM: Last updated on Fri Jan 28 21:50:28 1994
; $UID: n/a
; $REL: n/a
; $COM: SwazInfo include file
;**************************************************************


;
; This structure may be obtained as a semaphore of the name "SwazInfo"
;
; NOTE
;     If you are modifying this structure (only sis_OpenCount should be
;     modified), you should only do this inside a ObtainSemaphore()
;     ReleaseSemaphore() pair.
;

 STRUCTURE SwazInfoSem,SS_SIZE
	 ;--------------------------------------------------------------
	 ;
	 ; Flags and reserved fields
	 ;
	UBYTE	sis_Flags
	STRUCT	sis_Pad,3
	 ;--------------------------------------------------------------
	 ;
	 ; Version and revision numbers.
	 ;
	UWORD	sis_Version
	UWORD	sis_Revision
	UWORD	sis_Update

	 ;--------------------------------------------------------------
	 ;
	 ; sis_OpenCount is used as a locking mechanism for SwazInfo so
	 ; it cannot go away.
	 ;
	ULONG	sis_OpenCount

	 ;--------------------------------------------------------------
	 ;
	 ; These fields contain pointers to strings which contain the
	 ; version, copyright information etc about SwazInfo
	 ;
	STRPTR	sis_VersionString
	STRPTR	sis_TimeString
	STRPTR	sis_UserInfo
	STRPTR	sis_ReleaseInfo
	STRPTR	sis_Comment

	 ;--------------------------------------------------------------
	 ;
	 ; This is a hook to the WBInfo() routine used by SwazInfo as a
	 ; replacement for workbench.library/WBInfo. It follows the same
	 ; calling parameters etc.
	 ;
	 ; Example - Calling SwazInfo/WBInfo() from assembler:
	 ;
	 ;	move.l	SwazInfoBase,a6
	 ;	jsr	sis_WBInfo(a6)
	 ;
	STRUCT	sis_WBInfo,LIB_VECTSIZE

	 ;--------------------------------------------------------------
	 ;
	 ; This structure may be extended without notice :)
	 ;
	LABEL	sis_SIZEOF


*
* Flags for sis_Flags

sisB_Public	EQU 0
sisF_Public	EQU 1<<sisB_Public

