/***************************************************************/
/* defines                                                     */
/***************************************************************/
///
#define idle_none       0
#define idle_executive  1
#define idle_own        2

#define col_label       0
#define col_format      1
#define col_base        2
#define col_current     3
#define col_negative    4
#define col_bright      5
#define col_dark        6
#define col_bg          7

#define bg_none         0
#define bg_file         1
#define bg_snap         2

#define win_normal      0
#define win_fixed       1

#define bd_none         0
#define bd_simple       1
#define bd_standard     2
#define bd_double       3

#define ind_centered    0
#define ind_left        1
#define ind_right       2

#define typ_none            0
#define typ_all             1
#define typ_chip            2
#define typ_fast            3
#define typ_volume          4
#define typ_idle            5
#define typ_retina          6
#define typ_largest_chip    7
#define typ_largest_fast    8
#define typ_largest_total   9
#define typ_largest_retina  10
#define typ_clock_          11
#define typ_image           12
#define typ_virtual         13

#define typ_gauge       0
#define typ_histmeter   1
#define typ_clock       2
///
/***************************************************************/
/* gauge struct                                                */
/***************************************************************/
///
struct  GAU_Color
{
    UWORD   pen;
    ULONG   red;    /* if pen is TRUE, this is the pen number */
    ULONG   green;
    ULONG   blue;
};

struct tm_gau_set
{
    UWORD   type;
    UWORD   gauge_type;

    UWORD   size_y;     /* in 100+x percent of the font size ! */

    char    font[128];
    UWORD   font_size;

    char    label[16];
    char    format[128];

    char    expansion[128]; /* used for image type and volume */
    UWORD   indent;

    UWORD   sty_3d;
    UWORD   sty_border;
    UWORD   sty_bg;
    UWORD   sty_shadow;
    UWORD   sty_nogauge;
    UWORD   sty_noformat;
    UWORD   sty_nobase;

    struct  GAU_Color Colors[8];

    struct  tm_gau_set *next;
};
///
/***************************************************************/
/* System struct                                               */
/***************************************************************/
///
struct tm_sys_set
{
    char    set_header[4];
    UWORD   set_version;

    UWORD   x_pos;
    UWORD   y_pos;
    UWORD   x_siz;
    UWORD   colums;

    char    pub_name[128];

    char    font_name[40];
    UWORD   font_size;

    UWORD   bg_type;
    char    bg_picture[128];
    struct  GAU_Color bg_color;

    UWORD   vol_refresh;
    UWORD   mem_refresh;

    UWORD   start_wait;
    UWORD    start_usescreennotify;

    UWORD   win_move;
    UWORD   win_backfront;
    UWORD   win_border_x;
    UWORD   win_border_y;
    UWORD   win_space_x;
    UWORD   win_space_y;

    UWORD   bd_type;
    struct  GAU_Color bright_color;
    struct  GAU_Color dark_color;

    UWORD   Executive;
};
///
/***************************************************************/
/* tm_data                                                     */
/***************************************************************/
///
struct tm_data
{
    struct tm_sys_set *set;
    struct tm_gau_set *list;

    UWORD  num_of_gaug;
};
///
